
// include the library code:
#include <LiquidCrystal.h> // LiquidCrystal Library is supplied with the standard download 
#include <Time.h> // Get the Time Library from http://arduino.cc/playground/Code/Time

// initialize the LiquidCrystal library using 6 pins rs, enable, d4, d5, d6, d7
LiquidCrystal lcd(8,9,10,11,12,13);

long interval = 1; // How many seconds between outputting cell data
long previousSeconds = 0;
float Cell0;
float Cell1;
float Cell2;
float Cell3;

void setup() {
     Serial.begin(57600);
     // set up the LCD's number of columns and rows:
     // A 1x16 Line display is addressed as 2x8
     lcd.begin(8, 2);
}

void loop() {
     Cell0 = analogRead(A0);
     Cell1 = analogRead(A1);
     Cell2 = analogRead(A2);
     Cell3 = analogRead(A3);
  
     lcd.setCursor(0, 0);
     lcd.print((Cell0/1023)*5,1);
     lcd.setCursor(4, 0);
     lcd.print((Cell1/1023)*5,1);
     lcd.setCursor(0, 1);  // (cursor position 0, 1 is the 9th chr position on my 16x1 LCD
     lcd.print((Cell2/1023)*5,1);
     lcd.setCursor(4, 1);  // (cursor position 4, 1 is the 13th chr position on my 16x1 LCD
     lcd.print((Cell3/1023)*5,1);
     
     // Only send data to the serial port at interval in seconds
     unsigned long currentSeconds = now();
     if(currentSeconds - previousSeconds == interval) {
                 previousSeconds = currentSeconds;
                 senddata();
                 }
                 
   delay (500); // wait 500 miliseconds before doing it all again it's a nice speed for LCD
}

// senddata function prints the time and cell voltages to the serial port
// the format is time,cell1,voltage,cell2,voltage,cell3,voltage,cell4,voltage
// So if the cells were all at 1.23 volts after one hour 23 minutes and 45 seconds 
// the data output to the serial port would be 01:23:45,1,1.23,2,1.23,3,1.23,4,1.23

void senddata() {
      if (hour() < 10)       // If the hours are from 1 to 9 
          Serial.print('0'); // Print a leading zero so 1 hour prints as 01 
      Serial.print(hour());  // Print hours
      Serial.print(":");     // Hour and Minute seperator is a colon
      if (minute() < 10)     // If the minutes are from 1 to 9 
          Serial.print('0'); // Prints leading zero 1 minute prints as 01 
      Serial.print(minute());// Print minutes
      Serial.print(":");     // Minute and Second seperator is a colon
      if (second() < 10)     // If the seconds are from 1 to 9 
          Serial.print('0'); // Prints leading zero 1 second prints as 01 
      Serial.print(second());// Print Seconds
      
      Serial.print(",1,");   // Print cell number and it's voltage as comma separated values
      Serial.print((Cell0/1023)*5);
      Serial.print(",2,");     
      Serial.print((Cell1/1023)*5);
      Serial.print(",3,");         
      Serial.print((Cell2/1023)*5);
      Serial.print(",4,");             
      Serial.println((Cell3/1023)*5); // Last cell so output a newline
}
