#!/bin/sh
# This script reads the file called data every second and replots.
# It is useful for near realtime plots of captured data from
# another capture program or script such as record_data_from_ttyUSB0.sh
# Useage: 
# ./pipeintognuplot.sh | gnuplot

  echo set xdata time
  echo set timefmt \"%H:%M:%S\"
  echo set format x \"%H:%M:%S\"
  echo set datafile separator \",\"
  echo set title \"Battery discharge curves\"
  echo set yrange [0:2]
  echo set mytics
  echo set grid xtics ytics mytics
  echo set xlabel \"Time \(Hours:Minutes\)\"
  echo set ylabel \"Volts\"

while true; do # This is the loop that replots data realtime.

  echo plot \"data\" using 1:3 title \"Cell 1\" smooth bezier lw 2, \"data\" using 1:5 title \"Cell 2\" smooth bezier lw 2, \"data\" using 1:7 title \"Cell 3\" smooth bezier lw 2, \"data\" using 1:9 title \"Cell 4\" smooth bezier lw 2

sleep .5
done 

