#!/bin/sh
# Useage: 
# ./plotcells.sh name_of_the_log_to_plot
gnuplot -persist<<EOF
set xdata time
set timefmt "%H:%M"
set format x "%H:%M"
set datafile separator ","
set title "Battery discharge curves for $1"
set yrange [0:2]
set mytics
set grid xtics ytics mytics
set xlabel "Time (Hours:Minutes)"
set ylabel "Volts"
plot "$1" using 1:3 title "Cell 1" smooth bezier lw 1, "$1" using 1:5 title "Cell 2" smooth bezier lw 1, "$1" using 1:7 title "Cell 3" smooth bezier lw 1, "$1" using 1:9 title "Cell 4" smooth bezier lw 1
EOF
